// Assume "aArray" is the array to scan...
// ...and "xValue" is a LOCAL variable with a value to scan for

LOCAL xValue

//.......................................
//  Exactly equal scan
AScan( aArray, {| e | e == xValue } )

//.......................................
//  Soundex scan
AScan( aArray, {| e | Soundex( e ) == Soundex( xValue ) } )

//.......................................
//  Case-insensitive scan
AScan( aArray, {| e | Upper( e ) == Upper( xValue ) } )

//.......................................
//  Sub-array scan for "cFileName"
AScan( aArray, {| e | e[ F_NAME ] == Upper( cFileName ) } )



//.......................................
FUNCTION AScan( aArray, bExpr )
LOCAL i
   FOR i:= 1 TO Len( aArray )
      IF Eval( bExpr, aArray[ i ] )
         EXIT
      ENDIF
   NEXT
RETURN IIf( i <= Len( aArray ), i, 0 )

