/* AWIDTH.PRG - Return length of longest array element.

   The AWIDTH() function accepts an array and it returns the length of the
   longest element in the array.  The optional code block returns a width
   for each element that will be checked against each element instead of
   checking the length of the element itself.

   SYNTAX:  AWidth(aArray [,bEvaltoWidth] ) -> Width of longest element

   SWITCHES: /n /a /w /e

   ASSUMES: All elements are character or a code block is passed that
   returns a valid numeric for each array element.

   Copyright (c) 1990; The mks Group, Ltd.
   All Rights Reserved

*/
#include "mks50.ch"
//........................................................................
FUNCTION AWidth( aArray, bWidth )
LOCAL w:=0
   DEFAULT bWidth TO {|e| IIf( ValType( e )=="C", LEN(e), Len( Char( e ) ) ) }
   AEval(aArray,{|e| w:= Max(w,Eval(bWidth,e)) } )
RETURN(w)

/* Another way to do it.........................

FUNCTION AWidth( aArray, bWidth )
LOCAL nALen:= Len( aArray ),;
      nWidth:= 0, i
   DEFAULT bWidth TO {|e| Len(e) }
   FOR i:= 1 TO nALen
      nWidth:= Max( nWidth, Eval( bWidth, aArray[ i ] ) )
   NEXT
RETURN( nWidth )

...............................................*/
//........................................................................
// EOF: AWIDTH.PRG
