/* BOX.PRG - Box object for Clipper 5.0

   SWITCHES: /a /m /n /w

*/

#include "mks50.ch"

STATIC nBoxClass:= NIL

// Abstract and Encapsulate window object with psuedo-functions
#translate BTopRow( <b> )   => <b>\[2]
#translate BLeftCol( <b> )  => <b>\[3]
#translate BBottRow( <b> )  => <b>\[4]
#translate BRightCol( <b> ) => <b>\[5]

//....................................................
FUNCTION BoxNew( nTr, nLc, nBr, nRc )
   DEFAULT nBoxClass TO ClassIDNew( "box" )
RETURN( { nBoxClass, nTr, nLc, nBr, nRc } )

//....................................................
FUNCTION IsBoxClass( _Box )
RETURN( ClassID( _Box ) == nBoxClass )

//....................................................
FUNCTION BoxTopRow( _Box )
RETURN BTopRow( _Box )

//....................................................
FUNCTION BoxLeftCol( _Box )
RETURN BLeftCol( _Box )

//....................................................
FUNCTION BoxBottRow( _Box )
RETURN BBottRow( _Box )

//....................................................
FUNCTION BoxRightCol( _Box )
RETURN BRightCol( _Box )

//....................................................
PROCEDURE BoxShow( _Box )
LOCAL nTr:= BTopRow( _Box ),  nLc:= BLeftCol( _Box ),;
      nBr:= BBottRow( _Box ), nRc:= BRightCol( _Box )
   PushColor( ColorLabel() )
   @ nTr, nLc CLEAR TO nBr, nRc
   SetColor( ColorBox() )
   @ nTr, nLc TO nBr, nRc DOUBLE
   PopColor()
RETURN

//....................................................
// EOF: BOX.PRG
