// CBMENU.PRG - Office Automation Menu Object Definitions.

#include "mks50.ch"


//............................................................
FUNCTION CBMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Code Block Demo - Main Menu",;
      {  OptionNew( "Definition","", {|| CBTextBox( 50, MemoRead( "DEFINE.EX" ) ) } ),;
         OptionNew( "Syntax","", CBSMenu() ),;
         OptionNew( "Funcs","", CBFMenu() ),;
         OptionNew( "Iterators","", CBIMenu() ),;
         OptionNew( "Examples","", CBEMenu() ),;
         OptionNew( "Quit","", CBQMenu() ) } )

RETURN OBJECT aMenu

//............................................................
STATIC FUNCTION CBIMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Iterators Menu",;
      {  OptionNew( "AEval()",,   {|| CBTextBox( 65, MemoRead( "AEVAL.EX" ) ) } ),;
         OptionNew( "DBEval()",,  {|| CBTextBox( 60, MemoRead( "DBEVAL.EX" ) ) } ),;
         OptionNew( "DBSumAll()",,{|| CBTextBox( 65, MemoRead( "DBSUMALL.EX" ) ) } ) } )

RETURN OBJECT aMenu

//............................................................
STATIC FUNCTION CBFMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Functions Menu",;
      {  OptionNew( "AScan()",,   {|| CBTextBox( 70, MemoRead( "ASCAN.EX" ) ) } ),;
         OptionNew( "ASort()",,   {|| CBTextBox( 60, MemoRead( "ASORT.EX" ) ) } ),;
         OptionNew( "LiteBar()",, {|| CBTextBox( 70, MemoRead( "LOTUS123.EX" ) ) } ),;
         OptionNew( "GetKey()",,  {|| CBTextBox( 72, MemoRead( "GETKEY.EX" ) ) } ),;
         OptionNew( "ErrorBlock()",, {|| CBTextBox( 65, MemoRead( "EB.EX" ) ) } ) } )

RETURN OBJECT aMenu

//............................................................
STATIC FUNCTION CBEMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Examples Menu",;
      {  OptionNew( "1. AChoice()",,     {|| CBE1()  } ),;
         OptionNew( "2. SelectFiles()",, {|| SelectFiles("*.*", 7, 15 ) } ),;
         OptionNew( "3. ASCII_Pick()",,  {|| CBE3() } ),;
         OptionNew( "4. MENU.PRG",,      {|| CBTextBox( 75, MemoRead( "MENU.PRG" ) ) }  ),;
         OptionNew( "5. OPTION.PRG",,    {|| CBTextBox( 75, MemoRead( "OPTION.PRG" ) ) }  ),;
         OptionNew( "6. CB.PRG",,        {|| CBTextBox( 75, MemoRead( "CB.PRG" ) ) }  ),;
         OptionNew( "7. CBMENU.PRG",,    {|| CBTextBox( 75, MemoRead( "CBMENU.PRG" ) ) }  ),;
         OptionNew( "A. ASCII.PRG",,     {|| CBTextBox( 75, MemoRead( "ASCII.PRG" ) ) }  ),;
         OptionNew( "B. SELECTFI.PRG",,  {|| CBTextBox( 75, MemoRead( "SELECTFI.PRG" ) ) }  ),;
         OptionNew( "C. ACHOICE.PRG",,   {|| CBTextBox( 75, MemoRead( "ACHOICE.PRG" ) ) }  ) } )

RETURN OBJECT aMenu

//............................................................
STATIC PROCEDURE CBE3()
LOCAL nTr:= 5, nLc:= 20, nBr:= 22, nRc:= 54
   PushScr()
   BoxShow( BoxNew( nTr++, nLc++, nBr--, nRc-- ) )
   ASCII_Pick( nTr, nLc, nBr, nRc )
   PopScr()
RETURN

//............................................................
STATIC PROCEDURE CBE1()
LOCAL nTr:= 10, nLc:= 40, nBr:= 20, nRc:= 60
LOCAL aArray:= { "Red", "Green", "Blue", "Yellow", "Cyan", "Brown", "Orange" }
   PushScr()
   BoxShow( BoxNew( nTr++, nLc++, nBr--, nRc-- ) )
   AChoice( ++nTr, ++nLc, --nBr, --nRc , aArray )
   PopScr()
RETURN

//............................................................
STATIC FUNCTION CBSMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Syntax Menu",;
      {  OptionNew( "Basic",,  {|| CBTextBox( 14, MemoRead( "BCB.EX" ) ) } ),;
         OptionNew( "Eval()",, {|| CBTextBox( 40, MemoRead( "EVAL.EX" ) ) } ),;
         OptionNew( "Examples",,  {|| CBTextBox( 70, MemoRead( "EXAMPLE.EX" ) ) } ),;
         OptionNew( "Parameters",, {|| CBTextBox( 70, MemoRead( "PARAM.EX" ) ) } ) } )

RETURN OBJECT aMenu

//............................................................
STATIC FUNCTION CBQMenu()
STATIC OBJECT aMenu
   aMenu:= MenuNew( "Time to go...",;
      {  OptionNew( "Top Ten",,{|| CBTop10() } ),;
         OptionNew( "Go bye-bye",, {|| __Keyboard( Chr(27)+Chr(27) ) } ) } )

RETURN OBJECT aMenu

//............................................................
PROCEDURE CBTextBox( nWidth, cString )
LOCAL nTr, nLc, nBr, nRc
LOCAL nHeight:= Min( MaxRow() - 6, MLCount( cString, nWidth ) + 2 )
   nBr:= ( nTr:= ( MaxRow() - nHeight ) / 2 + 1 ) + nHeight + 1
   nRc:= ( nLc:= ( MaxCol() - nWidth ) / 2 ) + nWidth + 1
   PushScr()
   BoxShow( BoxNew( nTr++, nLc++, nBr--, nRc-- ) )
   MemoEdit( cString, ++nTr, ++nLc, --nBr, --nRc , FALSE )
   PopScr()
RETURN

//............................................................
PROCEDURE DispFileAction( cAction, cFileName )
   IF ( cFileName == NIL )
      @ 23,00
   ELSE
      @ 23,00 SAY cAction + " "+ cFileName + "..."
   ENDIF
RETURN

//............................................................
// EOF: CBMENU.PRG

