/* CLASS.PRG - Object Class functions

*/
#define NOCLASS
#include "mks50.ch"
STATIC aClassList:= NIL,;
       nID

//........................................................................
FUNCTION ClassIDNew( cName )   // Returns a unique Class Id when queried.
//   DEFAULT aClassList TO ListNew()
//   IF ( cName == NIL .OR. Empty( cName ) )
//      ErrorAbort( "No Class Name Specified." )
//   ENDIF
//RETURN( ListAdd( aClassList, Upper( cName ) ) )
   DEFAULT aClassList TO ListNew()
   IF ( ListScan( aClassList, cName:= Upper( cName ) ) == 0 )
      ListAdd( aClassList, Upper( cName ) )
   ENDIF
RETURN( cName )

//........................................................................
// Allow child to inherit from parent
FUNCTION ClassInherit( _Obj, aAttribs, nClassID )
   _Obj:= ACombine( _Obj, aAttribs )
   _Obj[1]:= nClassID
RETURN( _Obj )

//........................................................................
//FUNCTION ClassNextID()   // Returns next unique Class Id to be assigned
//RETURN( ListSize( aClassList ) + 1 )

//........................................................................
FUNCTION IsClass( _Obj )   // Is the object a Class?
//LOCAL nID:= ClassID( _Obj ),;    // Numeric if a class, NIL if not.
//      lIsClass:= FALSE
//   IF ( nID != NIL )
//      lIsClass:= ( nID > 0 ).AND.( nID <= ListSize( aClassList ) )
//   ENDIF
//RETURN( lIsClass )
LOCAL lIsClass:= FALSE
   IF ( ValType( _Obj ) == "A" ).AND.;
      ( Len( _Obj ) >= 1 ).AND.;
      ( ValType( _Obj[1] ) == "C" )
         lIsClass:= ( ListScan( aClassList, _Obj[1] ) > 0 )
   ENDIF
RETURN( lIsClass )
//........................................................................
FUNCTION ClassName( _Obj )       // Is the object a Class?
//LOCAL nID:= ClassID( _Obj ),;    // Numeric if a class, NIL if not.
//      cName:= ""
//   IF ( nID != NIL )
//      cName:= ListRetrieve( aClassList, nID )
//   ENDIF
//RETURN( cName )
RETURN( IIf( ValType( _Obj ) == "A", _Obj[ 1 ], NIL ) )

//........................................................................
FUNCTION ClassID( _Obj )   // Returns the class ID for a given object.
//LOCAL nID:= NIL, n1stEle
//   IF ( ValType( _Obj ) == "A" )
//      n1stEle:= _Obj[1]
//      IF ( ValType( n1stEle ) == "N" )
//         nID:= n1stEle
//      ENDIF
//   ENDIF
//RETURN( nID )
RETURN( IIf( ValType( _Obj ) == "A", _Obj[ 1 ], NIL ) )

//........................................................................
// EOF: CLASS.PRG
