//................................................
LOCAL aSums
   USE mydbf
   aSums:= DBSumAll()
   ? "Sums for each numeric field"
   FOR i:= 1 TO FCount()
      IF ( aSums[ i ] != NIL )
         ? PadR( FieldName( i ), 10 ), aSums[ i ]
      ENDIF
   NEXT
RETURN


//................................................
FUNCTION DBSumAll( bFor, bWhile )
LOCAL i, aSums[ FCount() ]
   IF ( bFor == NIL )
      bFor:= {|| .T. }
   ENDIF
   IF ( bWhile == NIL )
      bWhile:= {|| .T. }
   ENDIF
   // Fill with numeric values only elements
   // that correspond to numeric fields.
   FOR i:= 1 TO FCount()
      IF Type( Alias() + "->" + FieldName( i ) ) == "N"
         aSums[ i ]:= 0
      ENDIF
   NEXT
   DBEval( {|| SumFields( aSums ) }, bFor, bWhile )
RETURN( aSums )

//...................................................
STATIC PROCEDURE SumFields( aSumArray )
LOCAL i
   FOR i:= 1 TO Len( aSumArray )
      IF ( aSumArray[ i ] != NIL )
         aSumArray[ i ]+= FieldGet( i )
      ENDIF
   NEXT
RETURN
