/* LIST.PRG - List functions for Clipper 5.0.

  Functions included:

      _List:=  ListNew()
      nPos:=   ListAdd( _List, xItem )
      xItem:=  ListRetrieve( _List, nPos )
      nSize:=  ListSize( _List )
      xItem:=  ListRemove( _List, nPos )
      nPos:=   ListScan( _List, xItem/bBlock )
      lEmpty:= ListEmpty( _List )

*/
//..........................................................
FUNCTION ListNew()
RETURN( {} )

//..........................................................
FUNCTION ListAdd( _List, xItem )
   AAdd( _List, xItem )
RETURN( Len( _List ) )

//..........................................................
FUNCTION ListSize( _List )
RETURN( Len( _List ) )

//..........................................................
FUNCTION ListRetrieve( _List, nPos )
RETURN( _List[ nPos ] )

//..........................................................
FUNCTION ListRemove( _List, nPos )
LOCAL xItem:= _List[ nPos ]
   ADel( _List, nPos )
   ASize( _List, Len( _List ) - 1 )
RETURN( xItem )

//..........................................................
FUNCTION ListScan( _List, xbItem )
RETURN( AScan( _List, xbItem ) )

//..........................................................
FUNCTION ListEmpty( _List )
RETURN( Empty( _List ) )

//..........................................................

/*
STATIC PROCEDURE ListError( cDescription )
*   Eval( ErrorBlock(), ErrorNew( "LIST", ProcName(2), cDescription ) )
RETURN
*/

//..........................................................
// EOF: LIST.PRG



