/* MENU.PRG - Menu Package for Clipper 5.0

   SWITCHES: /a /m /n /w
*/
#include "mks50.ch"

// Abstract and Encapsulate menu object with psuedo-functions
#translate MTitle( <m> )         =>  <m>\[2]
#translate MOptions( <m> )       =>  <m>\[3]
#translate MExit( <m> )          =>  <m>\[4]
#translate MExit( <m>, <n> )     =>  <m>\[4]:= <n>
#translate MSelected( <m> )      =>  <m>\[5]
#translate MSelected( <m>, <n> ) =>  <m>\[5]:= <n>

#translate MenuAttrCnt()         =>  (5)

STATIC nMenuClassID:= NIL
//....................................................
FUNCTION MenuNew( cTitle, aOptions )
   DEFAULT nMenuClassID TO ClassIDNew( "menu" ),; // Get a unique ID for Menu Class
           cTitle TO "",;
           aOptions TO { OptionNew("Undefined") }
RETURN( { nMenuClassID,;   // Menu Class ID
          cTitle,;         // Menu Title
          aOptions,;       // Array of Options
          FALSE,;          // Exit this menu?
          1 } )            // Option Last Selected

//...........................................................................
FUNCTION MenuObjCheck( _Menu )
RETURN ( ObjCheck( _Menu, {;
   {|m,t|  ValType(t) == "C" },;
   {|m,ao| ValType(ao) == "A" .AND. ( AEval( ao, {|o| OptionObjCheck( o ) } ), TRUE ) },;
   {|m,e|  ValType(e) == "L" },;
   {|m,l|  ValType(l) == "N" } } ) )

//....................................................
FUNCTION MenuTitle( _Menu )
RETURN( MTitle( _Menu ) )

//....................................................
FUNCTION MenuOptions( _Menu )
RETURN( MOptions( _Menu ) )

//....................................................
FUNCTION MenuAttribCount()
RETURN( MenuAttrCnt() )

//....................................................
FUNCTION MenuLength( _Menu )
RETURN( Len( MOptions( _Menu ) ) )

//....................................................
FUNCTION MenuWidth( _Menu )
RETURN( AWidth( MOptions( _Menu ), {| aOpt | Len( OptionPrompt( aOpt ) ) } ) )

//....................................................
FUNCTION MenuSelected( _Menu, nNewSelect )
LOCAL nOldSelect
   nOldSelect:= MSelected( _Menu )
   IF ( nNewSelect <> NIL )
      MSelected( _Menu, nNewSelect )
   ENDIF
RETURN( nOldSelect )

//....................................................
FUNCTION IsMenuClass( _Menu )
RETURN( ClassID( _Menu ) == nMenuClassID )

//....................................................
FUNCTION MenuExit( _Menu, lNewExit )
LOCAL nOldExit
   nOldExit:= MExit( _Menu )
   IF ( lNewExit <> NIL )
      MExit( _Menu, lNewExit )
   ENDIF
RETURN( nOldExit )

//....................................................
// EOF: MENU.PRG
