/* MKS50.CH - Miscellaneous Clipper 5.0 Language Enhancements

   Copyright (c) 1990; Mike Schinkel
   All Rights Reserved

*/


// Include Nantucket's Header Files
#include "ACHOICE.CH"
#include "BOX.CH"
#include "DBEDIT.CH"
#include "ERROR.CH"
#include "FILEIO.CH"
#include "INKEY.CH"
#include "MEMOEDIT.CH"
#include "SET.CH"
#include "SETCURS.CH"

// Include MKS Header Files
#ifndef NOFLD
   #include "fld.ch"
#endif
#ifndef NOSYSTEM
   #include "system.ch"
#endif

#ifndef NORELATE
   #translate RelateNew( <t> ) => ;
              Relate_New( <t>, TO_NOCLOSE )
   #translate RelateNew( <t>, <p> ) => ;
              Relate_New( <t>, <p> )
   #translate RelateNew( <t>,, <k> ) => ;
              Relate_New( <t>, TO_NOCLOSE, <{k}>, Upper( <"k"> ) )
   #translate RelateNew( <t>, <p> , <k>) => ;
              Relate_New( <t>, <p>, <{k}>, Upper( <"k"> ) )
#endif

#ifndef NOGETFLD
   #translate GetFldNew( <r>, <c>, <n>, <stuff,...> ) => ;
              GetFld_New( <r>, <c>, Upper( <"n"> ), <stuff> )
   #translate GetFldNew( <r>, <c>, <n> ) => ;
              GetFld_New( <r>, <c>, Upper( <"n"> ) )
#endif

// Define several "convenience" commands
#command DEFAULT <var1> TO <value1> [,<varN> TO <valueN>] ;
=>;
         IF ( <var1> ==NIL); <var1>:=<value1>;  end;
         [;IF ( <varN> ==NIL); <varN>:=<valueN>;  end]

#command EXIT IF <log> =>   IF (<log>); EXIT; END
#command RETURN IF <log> => IF (<log>); RETURN; END
#command LOOP IF <log> =>   IF (<log>); LOOP; END

#command REPEAT =>   WHILE (.T.)
#command UNTIL <expr> =>  IF <expr>; EXIT; END; END

#command ENDFOR   => NEXT
#command ENDWHILE => ENDDO

#command STATIC <var> IS <val> =>;
         STATIC <var>; IF ( <var> ==NIL ); <var>:= <val>; ENDIF

#define LStr( s )         LTrim( Str( s ) )
#define TRUE (.T.)
#define FALSE (.F.)
#define CR_LF ( Chr(13) + Chr(10) )

// BOX BORDER
#define B_SOLID  ( Chr( 219 ) + Chr( 223 ) + Chr( 219 ) + Chr( 219 ) +;
                   Chr( 219 ) + Chr( 220 ) + Chr( 219 ) + Chr( 219 ) )

//...............................................................
// First element in an "object" (array) should have a unique numeric
// value generated via ClassIDNew

//   #translate ClassID( <o> ) => IIf( ValType( <o> )=="A", <o>[1], NIL )

//...............................................................

#command ATTEMPT <*func*> => <func>

//...............................................................

#translate MakeBlock( <e> ) => &( "{||" + <e> + "}" )

//...............................................................

#command PROGRAM <name> =>;
         PROCEDURE <name>( _1, _2, _3, _4, _5, _6, _7, _8, _9 );;
         LOCAL _:= ArgSet( { _1, _2, _3, _4, _5, _6, _7, _8, _9 } )

//...............................................................
// STATIC OBJECTS are used in functions that create a static object
#command STATIC OBJECT <arr> =>;
         STATIC <arr>:= {};;
            IF !Empty( <arr> );; // Is it already initialized?
               RETURN( <arr> );; // Don't initialize again.
            ENDIF;;

#command RETURN OBJECT <arr> => RETURN <arr>
// #command RETURN OBJECT <arr> =>;
//          RegisterMemory( {|| <arr>:= {} } );;
//          RETURN <arr>

//...............................................................
// #include "stack.ch"
// #include "list.ch"

//...............................................................
// EOF: LANG_ENH.CH
