/* OPTION.PRG - Option Package for Clipper 5.0

   SWITCHES: /a /m /n /w
*/
#include "mks50.ch"

#translate OptionID( <o> ) =>  ClassID( <o> )
#translate Prompt( <o> )   =>  <o>\[2]
#translate Message( <o> )  =>  <o>\[3]
#translate Sub( <o> )      =>  <o>\[4]

STATIC nOptionClassID:= NIL

//....................................................
FUNCTION OptionNew( cPrompt, cDescr, _bSub )
   DEFAULT nOptionClassID TO ClassIDNew( "option" ),;
           cDescr TO "",;
           _bSub TO {|| MsgWait("Not linked yet") }
RETURN ( { nOptionClassID, cPrompt, cDescr, _bSub } )

//...........................................................................
FUNCTION OptionObjCheck( _Option )
RETURN ( ObjCheck( _Option, {;
   {|m,p| ValType(p) == "C" .AND. !Empty( p ) },;
   {|m,d| ValType(d) == "C" },;
   {|m,s| ValType(s) == "B" .OR.;
        ( ClassName(s) == "MENU" .AND. ( MenuObjCheck( s ), TRUE ) ) .OR. ;
        ( ClassName(s) == "MODMENU" .AND. ( MenuObjCheck( s ), TRUE ) ) .OR.;
        TRUE } } ) )  // Tired of getting errors.

//....................................................
FUNCTION OptionPrompt( _Option )
RETURN( Prompt( _Option ) )

//....................................................
FUNCTION OptionMessage( _Option )
RETURN( Message( _Option ) )

//....................................................
FUNCTION OptionSub( _Option )
RETURN( Sub( _Option ) )

//....................................................
FUNCTION IsOptionClass( _Option )
RETURN( OptionID( _Option ) == nOptionClassID )


//....................................................
// EOF: OPTION.PRG
