/* PPCOLOR.PRG - Provide Save and Restore functions for Colors.

      PushColor() accepts a new color to SET and pushs on the stack the
   previous value of SetColor(). PopColor() resets the color by
   passing the value on the top of the color stack to the SetColor()
   function and then it removes that value from the stack.

   SWITCHES: /a /m /n /w

*/

STATIC aStack:= NIL

//..............................................
PROCEDURE PushColor( cNewColor )
   IF ( aStack == NIL )
      aStack:= StackNew()
   ENDIF
   StackPush( aStack, SetColor( cNewColor ) )
RETURN

//..............................................
PROCEDURE PopColor()
   SetColor( StackPop( aStack ) )
RETURN

//..............................................
// EOF: PPCOLOR.PRG
