/* PPCURSOR.PRG - Provide Save and Restore functions for Cursors.

   PushCursor() accepts a new cursor value to SET and pushs on the
   stack the previous value of SetCursor(). PopCursor() resets the
   crsor by passing the value on the top of the cursor stack with the
   SetCursor() function and then it removes that value from the stack.

   SWITCHES: /a /m /n /w

*/

STATIC aStack:= NIL

//..............................................
PROCEDURE PushCursor( cNewCursor )
   IF ( aStack == NIL )
      aStack:= StackNew()
   ENDIF
   StackPush( aStack, SetCursor( cNewCursor ) )
RETURN

//..............................................
PROCEDURE PopCursor()
   SetCursor( StackPop( aStack ) )
RETURN

//..............................................
// EOF: PPCURSOR.PRG
