/* PPKEYS.PRG - Provide Save and Restore functions for set keys.

   PushKey() accepts a key# and a new block to SET the key to and
   pushs on the stack the previous value of SetKey( key# ). PopKey()
   resets the key by passing the value on the top of the keys stack to
   the SetKey() function and then it removes that value from the
   stack.

   SWITCHES: /a /m /n /w

*/
#include "mks50.ch"

STATIC aStack:= NIL

// Abstract and Encapsulate key info with psuedo-functions
#define KeyNum( k )    k[1]
#define KeyBlock( k )  k[2]
#define KeyNew( n, b ) { n, b }

//..............................................
PROCEDURE PushKey( nKey, bNewBlock )
   IF ( aStack == NIL )
      aStack:= StackNew()
   ENDIF
   StackPush( aStack, KeyNew( nKey, SetKey( nKey, bNewBlock ) ) )
RETURN

//..............................................
PROCEDURE PopKey( nTimes )
LOCAL sKey
   DEFAULT nTimes TO 1
   WHILE ( nTimes-- > 0 )
      sKey:= StackPop( aStack )
      SetKey( KeyNum( sKey ), KeyBlock( sKey ) )
   ENDDO
RETURN

//..............................................
// EOF: PPKEYS.PRG
