/* PPSET.PRG - Provide Save and Restore functions for Sets.

   PushSet() accepts a set# and a new value to SET pushes on the stack
   the previous value of Set( set# ). PopSet() resets the set by
   passing the value on the top of the set stack to the Set()
   function and then it removes that value from the stack.

   SWITCHES: /a /m /n /w

*/
#include "mks50.ch"

STATIC aStack:= NIL

// Abstract and Encapsulate key info with psuedo-functions
#define SetNum( s )    s[1]
#define SetValue( s )  s[2]
#define SetNew( n, b ) { n, b }

//..............................................
PROCEDURE PushSet( nSet, bNewValue )
   IF ( aStack == NIL )
      aStack:= StackNew()
   ENDIF
   StackPush( aStack, SetNew( nSet, Set( nSet, bNewValue ) ) )
RETURN

//..............................................
PROCEDURE PopSet( nTimes )
LOCAL sSet
   DEFAULT nTimes TO 1
   WHILE ( nTimes-- > 0 )
      sSet:= StackPop( aStack )
      Set( SetNum( sSet ), SetValue( sSet ) )
   ENDDO
RETURN

//..............................................
// EOF: PPSET.PRG
