/* PULLDOWN.PRG - PullDown Menu Engine for mks50.LIB

   SWITCHES: /a /m /n /w
*/
#include "mks50.ch"

STATIC nSpecialKey:= 0,;   // Holds LEFT or RIGHT key values, or 0.
       lDown:= FALSE,;     // Lets Level 1 know if submenu should be down.
       lFakedIt:= FALSE    // Was Enter faked with a down arrow?

//....................................................
PROCEDURE PullDownGo( _Menu, bModuleMgr, nLevel, nRow, nCol )
LOCAL nMenuLen:= MenuLength( _Menu ), bDownKey
   DEFAULT nLevel TO 1
   DO CASE
   CASE ( nLevel == 1 )
      PushCursor( SC_NONE )
      bDownKey:= SetKey( K_DOWN, {|| Enter() } )
      PullDown1( _Menu, bModuleMgr, nLevel, nMenuLen )
      SetKey( K_DOWN, bDownKey )
      PopCursor()

   CASE ( nLevel == 2 )
      PushKey( K_DOWN, bDownKey )
      PushKey( K_LEFT,  {|| Arrow( K_LEFT ) } )
      PushKey( K_RIGHT, {|| Arrow( K_RIGHT ) } )
      lDown:= TRUE
      PullDown2( _Menu, bModuleMgr, nLevel, nMenuLen, nRow, nCol )
      IF ( nSpecialKey == 0 )
         lDown:= FALSE
      ENDIF
      PopKey( 3 )

   OTHERWISE
      PushKey( K_DOWN, bDownKey )
      PushKey( K_LEFT,  {|| NullProc() } )
      PushKey( K_RIGHT, {|| NullProc() } )
      PullDown2( _Menu, bModuleMgr, nLevel, nMenuLen, nRow, nCol+=3 )
      PopKey( 3 )

   ENDCASE
RETURN

//....................................................
STATIC PROCEDURE PullDown1( _Menu, bModuleMgr, nLevel, nMenuLen )
   PushScr()
   ScreenBackGround()
   MenuLoop(_Menu, bModuleMgr, nLevel, nMenuLen, {|i| 1 },;
            {|i| IIf(i==0, 02, Col()+3) } )
   PopScr()
RETURN

//....................................................
STATIC PROCEDURE PullDown2( _Menu, bModuleMgr, nLevel, nMenuLen, nRow, nCol )
LOCAL nMenuWidth:= MenuWidth( _Menu ),;
      nTr:= nRow+1, nLc:= nCol-2
LOCAL nBr:= nTr+nMenuLen+1, nRc:= nLc+nMenuWidth+3
   PushScr(nTr, nLc, nBr, nRc)
   @ nTr, nLc CLEAR TO nBr, nRc
   @ nTr, nLc TO nBr, nRc
   nLc+= 2
   MenuLoop( _Menu, bModuleMgr, nLevel, nMenuLen, {|i| nTr+i }, {|i| nLc } )
   PopScr()
RETURN

//....................................................
STATIC PROCEDURE MenuLoop( _Menu, bModuleMgr, nLevel, nMenuLen, bRow, bCol )
LOCAL i, aOption, xOptionSub,;
      nChoice:= IIf( nLevel == 1, 1, MenuSelected( _Menu ) ),;
      aRows[ nMenuLen ], aCols[ nMenuLen ]
PRIVATE n

   REPEAT
      IF ( nSpecialKey > 0 )            // Means a lower level action
         DO CASE                        // affected the current level
         CASE ( nSpecialKey == K_LEFT ) // Left below means move left
            IF ( nChoice > 1 )          // above (current)
               nChoice--
            ENDIF
         CASE ( nSpecialKey == K_RIGHT ) // Right below means move right
            IF ( nChoice < nMenuLen )    // above (current)
               nChoice++
            ENDIF
         ENDCASE
         nSpecialKey:= 0                  // Clear "flag"
      ENDIF
      PushColor( ColorMenu() )
      IF ( lDown ).AND.;                  // If it should remain down
         ( nLevel == 1 ) .AND.;           // and we are on the first level
         IsMenuClass( OptionSub( MenuOptions( _Menu )[ nChoice ] ) )
         KEYBOARD Chr( K_ENTER )          // force it down.
         PushSet( _SET_MESSAGE, 0 )       // Don't display message this level
      ELSE
         PushSet( _SET_MESSAGE, MaxRow() )     // Message OK this level
         @ MaxRow(), 0 CLEAR TO MaxRow(), MaxCol() // Clear last message
      ENDIF
      DevPos( Eval( bRow, 0 ), Eval( bCol, 0 ) )
      FOR i:= 1 TO nMenuLen
         @ aRows[i]:= Eval( bRow, i ), aCols[i]:= Eval( bCol, i ) ;
           PROMPT OptionPrompt( aOption:= ( MenuOptions( _Menu ) [ i ] ) ) ;
           MESSAGE OptionMessage( aOption )
      NEXT
      n:= nChoice;   MENU TO n;   nChoice:= n   // MENU TO BUG w/LOCAL.
      PopColor()
      PopSet()                                  // Message
      MenuSelected( _Menu, nChoice )            // Update the menu.
      IF ( nSpecialKey > 0 )  // We needed nChoice to be recorded
         nChoice:= 0          // before we cleared it.
      ELSE
         IF ( nChoice <> 0 )
            xOptionSub:= OptionSub( MenuOptions( _Menu )[ nChoice ] )
            DO CASE
            CASE ( ValType( xOptionSub ) == "B" )
               IF ( !lFakedIt ); Eval( xOptionSub )
               ELSE;             lFakedit:= FALSE
               ENDIF  // Don't execute if Enter was faked.
            CASE IsMenuClass( xOptionSub )
               lFakedit:= FALSE     // Ignore the fact it was faked now.
               PullDownGo( xOptionSub, bModuleMgr, nLevel+1,;
                           aRows[ nChoice ], aCols[ nChoice ] )
            ENDCASE
         ENDIF
      ENDIF
   UNTIL ( nChoice==0 )
RETURN

//....................................................
STATIC PROCEDURE Arrow( nKey )
   nSpecialKey:= nKey
   KEYBOARD Chr( K_ENTER )
RETURN

//....................................................
STATIC PROCEDURE Enter()
   lDown:= TRUE
   lFakedIt:= TRUE
   KEYBOARD Chr( K_ENTER )
RETURN

//....................................................
// EOF: PULLDOWN.PRG
