/* STACK.PRG - Stack functions for Clipper 5.0.

  Functions included:

      _Stack:= StackNew()
      StackPush( _Stack, xValue )
      xValue:= StackPop( _Stack )
      xValue:= StackTop( _Stack )
      lEmpty:= StackEmpty( _Stack )
*/
//..........................................................
FUNCTION StackNew()
RETURN( {} )

//..........................................................
FUNCTION StackPush( _Stack, xValue )
   AAdd( _Stack, xValue )
RETURN( _Stack )

//..........................................................
FUNCTION StackPop( _Stack )
LOCAL nStackDepth:= Len( _Stack )
LOCAL xValue
   IF StackEmpty( _Stack )
      ErrorAbort("Empty Stack")
   ENDIF
   xValue:= _Stack[ nStackDepth ]
   ASize( _Stack, --nStackDepth )
RETURN( xValue )

//..........................................................
FUNCTION StackTop( _Stack )
   IF StackEmpty( _Stack )
      ErrorAbort("Empty Stack")
   ENDIF
RETURN( _Stack[ Len( _Stack ) ] )

//..........................................................
FUNCTION StackEmpty( _Stack )
RETURN( Empty( _Stack ) )

//..........................................................
// EOF: STACK.PRG



