/* SYSTEM.PRG - System Object for Clipper 5.0

   SWITCHES: /a /m /n /w

*/
#define SYSTEM
#include "mks50.ch"

// Abstract and Encapsulate System object with psuedo-functions
#translate SysID( <s> )       =>   <s>\[2]
#translate SysTitle( <s> )    =>   <s>\[3]
#translate SysMenu( <s> )     =>   <s>\[4]

STATIC nSystemClassID:= NIL,;
       aSystemObj      // Only one system object

//....................................................
FUNCTION SystemObject()
   DEFAULT aSystemObj TO SystemNew()
RETURN( aSystemObj )

//....................................................
FUNCTION SystemNew( cSysID, cTitle, _Menu, aTables )
   DEFAULT nSystemClassID TO ClassIDNew( "system" ),;
           cSysID   TO "",;
           cTitle   TO ""
RETURN( aSystemObj:= { nSystemClassID,;
                       Upper( Left( cSysID, 2 ) ),;
                       cTitle,;
                       _Menu } )

//...........................................................................
FUNCTION SystemObjCheck( _System )
RETURN ( ObjCheck( _System, {;
   {|s,id| ValType(id) == "C" .AND. Len( id ) == 2 .AND. !Empty( id ) },;
   {|s,d|  ValType(d) == "C" },;
   {|s,m|  MenuObjCheck( m ), TRUE };
                            } ) )

//....................................................
FUNCTION SystemID( _System )
RETURN SysID( _System )

//....................................................
FUNCTION SystemTitle( _System )
RETURN SysTitle( _System )

//....................................................
FUNCTION SystemMenu( _System )
RETURN SysMenu( _System )

//....................................................
FUNCTION IsSystemClass( _System )
RETURN( ClassID( _System ) == nSystemClassID )

//...................................................
// EOF: SYSTEM.PRG



