/* TABLE.CH - Defines TABLE "structure" using an Array. */

//***** DEFINE Table Psuedo-Functions

#define TableFile(t)     t[1]       // Table file name and optional path
#define TableAlias(t)    t[2]       // Alias for the table
#define TableDescr(t)    t[3]       // Description for the table
#define TableIndexes(t)  t[4]       // Array of Indexes (described in index.ch)
#define TableIndexCnt(t) Len(t[4])  // Count of indexes for this table
#define TableIndexArr(t) t[5]       // Array of index file names

#translate TableNew(<cFile>, <idAlias>, <cDescr>, <aIndexes>);
=>;
   { <cFile>, <"idAlias">, <cDescr>, <aIndexes>, NIL }

//***** DEFINE Index Psuedo-Functions

#define IndexFile(i)     i[1]    // Name of index file
#define IndexCKey(i)     i[2]    // Character Key for the index file
#define IndexBKey(i)     i[3]    // Code Block for the index
#define IndexDescr(i)    i[4]    // Description for the index

#translate IndexNew(<cFile>, <idKey>, <cDescr>);
=>;
   { <cFile>, <"idKey">, <{idKey}>, <cDescr> }

//***** DEFINE UDC's to simplify use

#command DEFINE TABLE <t> NAME <n> ALIAS <a> DESCRIPTION <d> =>;
<t>:= {<n>, <"a">, <d>, NIL, NIL}

#command DEFINE INDEX LIST <i> ;
         NAME <n1> KEY <k1> DESCRIPTION <d1> ;
         [, NAME <nN> KEY <kN> DESCRIPTION <dN> ] ;
=>;
<i>:= { {<n1>, <"k1">, <{k1}>, <d1>} [, {<nN>, <"kN">, <{kN}>, <dN>} ] }


#command OPEN TABLE <t> [ORDER <n>] [<ro: READONLY>] ;
                        [<ex: EXCLUSIVE>] [<sh: SHARED>] ;
=> ;
         OpenTable( <t>, <n>, !<.ex.>, <.ro.> )

#command CLOSE TABLE <t>;
=> ;
         CloseTable( <t> )

//.............................................................
// EOF: TABLE.CH

